/*
   MicroDexed

   MicroDexed is a port of the Dexed sound engine
   (https://github.com/asb2m10/dexed) for the Teensy-3.5/3.6 with audio shield.
   Dexed ist heavily based on https://github.com/google/music-synthesizer-for-android

   (c)2018-2020 H. Wirtz <wirtz@parasitstudio.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
*/

#ifndef _UI_H_
#define _UI_H_

LCDML_add(0, LCDML_0, 1, "Setup", NULL);
LCDML_add(1, LCDML_0_1, 1, "MIDI Channel", UI_func_midi_channel);
LCDML_add(2, LCDML_0_1, 2, "Sound Intens.", UI_func_sound_intensity);
LCDML_add(3, LCDML_0_1, 3, "Transpose", UI_func_transpose);
LCDML_add(4, LCDML_0_1, 4, "Tune", UI_func_tune);
LCDML_add(5, LCDML_0_1, 5, "Panorama", UI_func_panorama);
LCDML_add(6, LCDML_0_1, 6, "Polyphony", UI_func_polyphony);
LCDML_add(7, LCDML_0_1, 7, "Engine", UI_func_engine);
LCDML_add(8, LCDML_0_1, 8, "Mono/Poly", UI_func_mono_poly);
LCDML_add(9, LCDML_0_1, 9, "Pitchbend", NULL);
LCDML_add(10, LCDML_0_1_9, 1, "PB Range", UI_func_pb_range);
LCDML_add(11, LCDML_0_1_9, 2, "PB Step", UI_func_pb_step);
LCDML_add(12, LCDML_0_1, 10, "Mod Wheel", NULL);
LCDML_add(13, LCDML_0_1_10, 1, "MW Range", UI_func_mw_range);
LCDML_add(14, LCDML_0_1_10, 2, "MW Assign", UI_func_mw_assign);
LCDML_add(15, LCDML_0_1, 11, "Foot Ctrl", NULL);
LCDML_add(16, LCDML_0_1_11, 1, "FC Range", UI_func_fc_range);
LCDML_add(17, LCDML_0_1_11, 2, "FC Assign", UI_func_fc_assign);
LCDML_add(18, LCDML_0_1, 12, "Breath Ctrl", NULL);
LCDML_add(19, LCDML_0_1_12, 1, "BC Range", UI_func_bc_range);
LCDML_add(20, LCDML_0_1_12, 2, "BC Assign", UI_func_bc_assign);
LCDML_add(21, LCDML_0_1, 13, "Aftertouch", NULL);
LCDML_add(22, LCDML_0_1_13, 1, "AT Range", UI_func_at_range);
LCDML_add(23, LCDML_0_1_13, 2, "AT Assign", UI_func_at_assign);
LCDML_add(24, LCDML_0_1, 14, "Portamento", NULL);
LCDML_add(25, LCDML_0_1_14, 1, "Port. Mode", UI_func_portamento_mode);
LCDML_add(26, LCDML_0_1_14, 2, "Port. Gliss", UI_func_portamento_glissando);
LCDML_add(27, LCDML_0_1_14, 3, "Port. Time", UI_func_portamento_time);
LCDML_add(28, LCDML_0_1, 15, "Operator", NULL);
LCDML_add(29, LCDML_0_1_15, 1, "OP1", UI_func_OP1);
LCDML_add(30, LCDML_0_1_15, 2, "OP2", UI_func_OP2);
LCDML_add(31, LCDML_0_1_15, 3, "OP3", UI_func_OP3);
LCDML_add(32, LCDML_0_1_15, 4, "OP4", UI_func_OP4);
LCDML_add(33, LCDML_0_1_15, 5, "OP5", UI_func_OP5);
LCDML_add(34, LCDML_0_1_15, 6, "OP6", UI_func_OP6);
LCDML_add(35, LCDML_0, 2, "Load/Save", NULL);
LCDML_add(36, LCDML_0_2, 1, "Load", UI_func_load);
LCDML_add(37, LCDML_0_2, 2, "Save", UI_func_save);
LCDML_add(38, LCDML_0, 3, "System", NULL);
LCDML_add(39, LCDML_0_3, 1, "Stereo/Mono", UI_func_stereo_mono);
LCDML_add(40, LCDML_0_3, 2, "MIDI Soft THRU", UI_func_midi_soft_thru);
#if defined(TEENSY_AUDIO_BOARD)
LCDML_add(41, LCDML_0_3, 3, "Output Level", UI_func_output_level);
LCDML_add(42, LCDML_0, 4, "Info", UI_func_information);
#define _LCDML_DISP_cnt 42
#else
LCDML_add(41, LCDML_0, 4, "Info", UI_func_information);
#define _LCDML_DISP_cnt 41
#endif
#define MENU_ID_OF_INSTANCE_2 35

#endif
